<?php

//互亿无线彩信

//打开php.ini文件中的 always_populate_raw_post_data = -1;
header("Content-type:text/html; charset=UTF-8");

class sms
{

    public $log_file = 'log.txt';
    public $config = array(
        'apiid' => 'xxxx',
        'apikey' => 'xxxxxxxxxxxx',
        'send_url' => "http://127.0.0.1:19012/api/batchSend",
        'template_url' => "http://127.0.0.1:19012/api/templateCreate",
        'balance_url' => "http://127.0.0.1:19012/api/balance",
    );

    public function __construct($config = array())
    {
        if ($config) {
            $this->config = $config;
        }
    }

    //请求数据到短信接口，检查环境是否 开启 curl init。
    private function post($curlPost, $url)
    {
        if(is_array($curlPost)){
            $curlPost = json_encode($curlPost);
        }
        $curl = curl_init();
        $header = array();
        $header[] = "Content-type: application/json";//定义content-type为json
        $header[] = "Content-Length: " . strlen($curlPost);//定义content-Length
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_HEADER, false);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HTTPHEADER, $header);
        curl_setopt($curl, CURLOPT_TIMEOUT, 10);//超时时间,最好不要太小，否则服务响应慢会丢包
        curl_setopt($curl, CURLOPT_CONNECTTIMEOUT, 10);
        curl_setopt($curl, CURLOPT_NOBODY, false);
        curl_setopt($curl, CURLOPT_POST, true);
        curl_setopt($curl, CURLOPT_POSTFIELDS, $curlPost);
        //curl_setopt($curl, CURLOPT_HEADER, true);

        if (strpos($url, "https") === 0){//访问SSL协议的URL https://
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false); // 是否验证ssl证书
            curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, 0); // 0表示不检查证书；1表示检查证书中是否有CN(common name)字段；2表示在1的基础上校验当前的域名是否与CN匹配
        }

        $res = curl_exec($curl);

        curl_close($curl);
        return $res;
    }

    //发送短信
    public function send($mobile, $content=array(), $title, $product_id, $sign_name, $send_time = '', $request_id = '',$template_id = 0)
    {
        $template_id = intval($template_id);
        $target = $this->config['send_url'];
        $timestamp = time();
        if (empty($request_id)) {
            $request_id = time() . '_' . rand(11111, 99999);
        }
       
        $post_data = array(
            'api_id' => $this->config['apiid'],
            'signature' => $this->signature($request_id,$timestamp),
            'phone' => $mobile,
            'sign_name' => $sign_name,
            'request_id' => $request_id,
            'timestamp' => $timestamp,
            'product_id' => $product_id,
            'send_time' => $send_time,
            'title'     => $title
        );
        if(empty($content) && $template_id<=0 ) {
            return ['缺少参数'];
        }
        if($content) {
            $post_data['content'] = $content;
        }else {
            $post_data['template_id'] = $template_id;
        }
        try {
            $this->log('send', $post_data);
            $res = $this->post($post_data, $target);
            if($res){
                return json_decode($res, true);
            }else{
                return ['请求失败'];
            }
        } catch (\Exception $e) {
            return [$e->getMessage()];
        }
    }

    //提交模板
    public function template($title, $content, $purpose, $sign_name)
    {
        $target = $this->config['template_url'];
        $timestamp = time();
        if (empty($request_id)) {
            $request_id = time() . '_' . rand(11111, 99999);
        }
        $post_data = array(
            'api_id' => $this->config['apiid'],
            'signature' => $this->signature($request_id,$timestamp),
            'request_id' => $request_id,
            'timestamp' => $timestamp,
            'title' => $title,
            'content' => $content,
            'purpose' => $purpose,
            'sign_name' => $sign_name
        );
        try {
            $this->log('template', $post_data);
            $res = $this->post($post_data, $target);
            if($res){
                return json_decode($res, true);
            }else{
                return ['请求失败'];
            }
        } catch (\Exception $e) {
            return [$e->getMessage()];
        }
    }

    //获取余额
    public function balance($request_id = '')
    {

        $target = $this->config['balance_url'];
        $timestamp = time();
        $request_id = $timestamp . '_' . rand(11111, 99999);
        $signature = 'api_id=' . $this->config['apiid'] . '&' . 'api_key=' . $this->config['apikey'] . '&' . 'request_id=' . $request_id . '&' . 'timestamp=' . $timestamp;
        $post_data = array(
            'api_id' => $this->config['apiid'],
            'signature' => md5($signature),
            'request_id' => $request_id,
            'timestamp' => $timestamp
        );
        try {
            $res = $this->post($post_data, $target);
            if($res){
                return json_decode($res, true);
            }else{
                return ['请求失败'];
            }
        } catch (\Exception $e) {
            return [$e->getMessage()];
        }

    }

    public function signature($request_id,$timestamp)
    {
        $signature = 'api_id=' . $this->config['apiid'] . '&' . 'api_key=' . $this->config['apikey'] . '&' . 'request_id=' . $request_id . '&' . 'timestamp=' . $timestamp;

        return md5($signature);
    }

    //接收回执推送
    public function get_report()
    {
        $json = file_get_contents( "php://input" );
        $this->log('report', $json);
        return $json;
    }

    //接收上行推送
    public function get_reply()
    {
        $json = file_get_contents( "php://input" );
        $this->log('reply', $json);
        return $json;
    }

    //接收模板审核推送
    public function get_template_report()
    {
        $json = file_get_contents( "php://input" );
        $this->log('template_report', $json);
        return $json;
    }

    //写日志
    //请确保log目录有写的权限
    public function log($filename, $content)
    {
        if(is_array($content)){
            $content = json_encode($content, 256);
        }
        file_put_contents('log/'.$filename.'_log.'.date('Y_m_d').'.txt', date('Y-m-d H:i:s').' '.$content."\r\n", FILE_APPEND);
    }

}
